"use strict";

var shortid = require("shortid"),
    recorder = require("actions-recorder");

exports.create = function (text) {
  return recorder.dispatch("todo/create", {
    text: text,
    id: shortid.generate()
  });
};

exports.update = function (id, text) {
  return recorder.dispatch("todo/update", {
    id: id,
    text: text
  });
};

exports.toggle = function (id) {
  return recorder.dispatch("todo/toggle", id);
};

exports.remove = function (id) {
  return recorder.dispatch("todo/remove", id);
};

exports.archive = function () {
  return recorder.dispatch("todo/archive");
};