"use strict";

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

var IncrementalDOM = require("incremental-dom");

var elementOpen = IncrementalDOM.elementOpen;
var elementVoid = IncrementalDOM.elementVoid;
var elementClose = IncrementalDOM.elementClose;
var text = IncrementalDOM.text;

var object2array = function object2array(properties) {
  properties = properties || {};
  var result = [];
  var fields = Object.keys(properties);
  fields.forEach(function (key) {
    return result.push(key, properties[key]);
  });
  return result;
};

var selfClosing = ["area", "base", "br", "col", "embed", "hr", "img", "input", "keygen", "link", "meta", "param", "source", "track", "wbr"];

var createElement = function createElement(tagName, staticAttrs, properties, cb) {
  if (typeof(properties) === "function") {
    cb = properties;
    properties = {};
  }

  var propertiesInArray = object2array(properties);

  if (selfClosing["indexOf"](tagName) >= 0) {
    elementVoid.apply(undefined, [tagName, staticAttrs.key, object2array(staticAttrs)].concat(_toConsumableArray(propertiesInArray)));
  } else {
    elementOpen.apply(undefined, [tagName, staticAttrs.key, object2array(staticAttrs)].concat(_toConsumableArray(propertiesInArray)));
    if (cb != null) cb()
    elementClose(tagName);
  }

  return undefined;
},
    createFactory = function createFactory(tagName) {
  return function (staticAttrs, properties, cb) {
    return createElement(tagName, staticAttrs, properties, cb);
  };
};

exports.createElement = createElement;
exports.createFactory = createFactory;
exports.patch = IncrementalDOM.patch;
exports.text = text;
var definedTags = ["div", "span", "input", "textarea"];
definedTags.forEach(function (tagName) {
  return exports[tagName] = exports.createFactory(tagName);
});